﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win.UltraWinSchedule.DayView;

namespace _141226
{
    public partial class Form1 : Form
    {

        public struct IconInfo
        {
            public bool fIcon;
            public int xHotspot;
            public int yHotspot;
            public IntPtr hbmMask;
            public IntPtr hbmColor;
        }

        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool GetIconInfo(IntPtr hIcon, ref IconInfo pIconInfo);

        [DllImport("user32.dll")]
        public static extern IntPtr CreateIconIndirect(ref IconInfo icon);

        public static Cursor CreateCursor(Bitmap bmp, int xHotSpot, int yHotSpot)
        {
            IntPtr ptr = bmp.GetHicon();
            IconInfo tmp = new IconInfo();
            GetIconInfo(ptr, ref tmp);
            tmp.xHotspot = xHotSpot;
            tmp.yHotspot = yHotSpot;
            tmp.fIcon = false;
            ptr = CreateIconIndirect(ref tmp);
            return new Cursor(ptr);
        }

        Cursor repCursor; 
        public Form1()
        {
            InitializeComponent();
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Bitmap cur = (Bitmap) Bitmap.FromFile("..\\..\\cur.png");
            Bitmap bitmap = new Bitmap(140, 50);
            Graphics g = Graphics.FromImage(bitmap);
            using (Font f = new Font(FontFamily.GenericSansSerif, 10))
            {
                g.DrawImage(cur, new Point(0, 0));
                g.DrawString("Replace", f, Brushes.Green, 0, 0);
            }

            repCursor = CreateCursor(bitmap, 3, 3);

            cur.Dispose();
            bitmap.Dispose();
       
            Appointment app1 = new Appointment(DateTime.Now, DateTime.Now.AddMinutes (30));
            app1.Subject = "Subject app1";
            app1.Description = "Description app1";

            Appointment app2 = new Appointment(DateTime.Now.AddMinutes (90), DateTime.Now.AddMinutes (120));
            app2.Subject = "Subject app2";
            app2.Description = "Description app2";

            ultraCalendarInfo1.Appointments.AddRange(new Appointment[] { app1, app2 });

            ultraDayView1.EnsureTimeSlotVisible(DateTime.Now, true);
        }

        private void ultraDayView1_AppointmentsDragging(object sender, AppointmentsDraggingEventArgs e)
        {
            if (ModifierKeys == Keys.Alt )
            {
                Debug.WriteLine(DateTime.Now);
                e.AllowCopy = false;
                UltraDayView dayView = (UltraDayView)sender;
                UIElement el = dayView.UIElement.ElementFromPoint(dayView.PointToClient(Cursor.Position));
                AppointmentUIElement appOver = (AppointmentUIElement)el.GetAncestor(typeof(AppointmentUIElement));
                if (appOver != null && !appOver.Appointment.Equals(e.Appointments[0]))
                     e.MoveCursor = repCursor;
                switch (e.Phase)
                { 
                    case AppointmentDragPhase.Ending:

                        if (appOver != null && !appOver.Appointment.Equals(e.Appointments[0]))
                        {
                            e.Appointments[0].Owner = appOver.Appointment.Owner;
                            dayView.CalendarInfo.Appointments.Remove(appOver.Appointment);
                        }

                        break;
                }
            }
        }
    }
}
